#                                         -*- mode: Makefile -*-

SCMDIRS 	= interfaces/guile lookout type ui

GUILECC 	= guild compile
GUILECCFLAGS 	= --warn=unbound-variable
GUILECCFLAGS	+= -L$(SDK_DIR) -L$(shell pwd)

SCM	= $(foreach dir,$(SCMDIRS),$(wildcard $(dir)/*.scm $(dir)/*/*.scm $(dir)/*/*/*.scm $(dir)/*/*/*/*.scm))
SCMUI	= $(wildcard ui/*/index.scm ui/*/*/index.scm ui/*/*/*/index.scm)
GO	= $(patsubst %.scm,%.go,$(patsubst %,$(libexecdir)/alterator/%,$(filter-out $(SCMUI) $(SCM_SKIP_CC),$(SCM))))

$(libexecdir)/alterator/%.go: %.scm
	if [ -x /usr/bin/guild ]; then $(GUILECC) $(GUILECCFLAGS) -o $@ $<; fi

install-cc: $(GO)

$(GO):	| installdirs-cc

installdirs-cc:
	ln -s interfaces/guile alterator
	for d in $(SCMDIRS); do mkdir -p $(libexecdir)/alterator/$$d; done
