(define-module (alterator common)
  :use-module (system vm vm)
  :use-module (alterator str)
  :use-module (srfi srfi-1)
  :export (
           alterator-init-local
           alterator-init-global

           turn-on-debugging

           program-name))

; Use UTF-8 I/O by default for all ports here and then
(fluid-set! %default-port-encoding "UTF-8")
(set-port-encoding! (current-input-port) "UTF-8")
(set-port-encoding! (current-output-port) "UTF-8")
(set-port-encoding! (current-error-port) "UTF-8")

(define (alterator-init-global)
  (or (getenv "ALTERATOR_DATADIR")
      (setenv "ALTERATOR_DATADIR" "/usr/share/alterator"))
  (or (getenv "ALTERATOR_LIBDIR")
      (setenv "ALTERATOR_LIBDIR" "/usr/lib/alterator"))
  (set! %load-path
        (fold cons
              %load-path
              (reverse (string-split (or (getenv "ALTERATOR_DATADIR") "") #\:)))))

(define (alterator-init-local)
  (alterator-init-global)
  (set! %load-path (cons "." %load-path))
  (setenv "ALTERATOR_DEBUG" "1")
  (setenv "ALTERATOR_DATADIR"
          (string-append "." ":" (getenv "ALTERATOR_DATADIR")))
  (setenv "ALTERATOR_LIBDIR"
          (string-append "." ":" (getenv "ALTERATOR_LIBDIR"))))

(define (turn-on-debugging)
  (set-default-vm-engine! 'debug)
  (set-vm-engine! 'debug))

(define program-name (basename (car (command-line))))

