(define-module (alterator uri)
  :use-module (alterator str)
  :export (split-document-uri))

(define (split-document-query query)
  (if query
      (map (lambda(keyval)
             (let* ((splitted (string-split keyval #\=))
                    (key (string->symbol (car splitted)))
                    (val (string-join (cdr splitted) "=")))
               (cons key val)))
           (string-split query #\&))
      '()))

(define (split-document-uri uri)
  (if uri
      (let* ((splitted (string-split (->string uri) #\?))
             (path (car splitted))
             (query (string-join (cdr splitted) "?")))
        (cons path (split-document-query query)))
      (cons uri '())))
