(define-module (type hostname-or-ip)
    :use-module (alterator woo)
    :use-module ((type ip-address) :select (ip-address?))
    :use-module ((type hostname) :select (hostname?))
    :export (hostname-or-ip?
             type))

(define (hostname-or-ip? str)
  (and (string? str)
       (or (hostname? str)
           (ip-address? str))))

(define (type v _)
  (or (and (string? v) (string-null? v))
      (hostname-or-ip? v)
      (type-error (_ "only IP address or a hostname (latin letters, digits, '-', '.', and '_') is allowed"))))
