(define-module (type integer)
    :use-module (alterator woo)
    :export (type))

(define *integer-regex-str* "^[0-9]+$")
(define *integer-regex* (make-regexp *integer-regex-str* regexp/extended))

(define (type v _)
  (or (and (number? v) (integer? v))
      (and (string? v) (string-null? v))
      (and (string? v) (regexp-exec *integer-regex* v))
      (type-error (_ "integer number string should contain only the 0-9 digits"))))
