(define-module (type ip-address)
  :use-module (alterator woo)
  :use-module ((type ipv6-address) :select (ipv6-address?))
  :use-module ((type ipv4-address) :select (ipv4-address-regex))
  :export (ip-address?
           type))

(define (ip-address? ip)
  (and (string? ip)
    (or (regexp-exec ipv4-address-regex ip)
        (ipv6-address? ip))))

(define (type v _)
  (or (and (string? v) (string-null? v))
      (ip-address? v)
      (type-error (_ "invalid IP address"))))
