(define-module (type ipv6-network)
  :use-module (srfi srfi-2)
  :use-module (alterator woo)
  :use-module (alterator algo)
  :use-module (alterator str)
  :use-module ((type ipv6-address) :select (ipv6-address?))
  :export (ipv6-network?
           type))

(define (ipv6-network? s)
  (and (string? s)
       (and-let* ((p_str (cond-cadr (string-cut s #\/)))
                  (prefix (string->number p_str))
                  (addr (cond-car (string-cut s #\/))))
                 (and (ipv6-address? addr)
                      (>= prefix 1)
                      (<= prefix 128)))))

(define (type v _)
  (or (and (string? v) (string-null? v))
      (ipv6-network? v)
      (type-error (_ "invalid IPv6 network specification"))))
