(define-module (type keyword)
    :use-module (alterator woo)
    :export (type))

;; A key-word is one word of letters and digits (plus "_" and "-"), starting
;; with a letter or "_".
(define *keyword-regex-str* "^[_a-zA-Z][a-zA-Z0-9_-]*$")
(define keyword-regex (make-regexp *keyword-regex-str* regexp/extended))

(define (type v _)
  (or (and (string? v) (string-null? v))
      (and (string? v) (regexp-exec keyword-regex v))
      (type-error (_ "a key-word is one word of letters and digits (plus \"_\" and \"-\"), starting with a letter or \"_\""))))
