(define-module (type number)
    :use-module (alterator woo)
    :export (type))

(define *number-regex-str* "^[0-9]+(\\.[0-9]+)?$")
(define *number-regex* (make-regexp *number-regex-str* regexp/extended))

(define (type v _)
  (or (number? v)
      (and (string? v) (string-null? v))
      (and (string? v) (regexp-exec *number-regex* v))
      (type-error (_ "number string should contain only the 0-9 digits and one optional decimal point"))))
